﻿<#
random-file-gen-from-file-copy
.Description
This script creates multiple copies of a file, with each file having a unique and random file name. The filenames are generated from a list that I created of about 50 words.
I find the script useful when testing ransomware variants. I can create a large number of files on the fly, for the ransomware to attack. Some ransomware performs a spot check, 
to determine how many office files or pdf files exist on the system. And if not enough files are found, the encryption process will not run. Very clever ransomware devs...
.How to use
You'll need to edit lines 21 and 30. Line 21, is the location of the word list. Line 30 is the location of the original file, that the script will make copies of.
.Optional
Modify line 40. This controls the file extensions that are used when creating the random files. You can add or subtract extensions.
.Created by
Nathan Studebaker
#>

#Input parameter for specifying how many files to create and in what directory they should be created
param(
      [Parameter(mandatory=$true)]$NumberOfFiles,
      [Parameter(mandatory=$true)]$path
)
#Location of the word list that is used for creating the random file names
$global:csv = import-csv 'C:\test\filename list.csv' ####edit this line to reflect the full path to the filename csv file.

#Set filecount to 0
$filecount = 0

#While loop for creating the files
while ($filecount -lt $NumberofFiles) 
    {
        #Specify the original file that we'll make copies of 
        $ofile = 'C:\test\WatchPoint Data Template File.docx'            #edit this line to reflect the full path to the template file.
        $verb1 = $csv[(Get-Random -Maximum ([array]$csv).count)]
        $verb2 = $csv[(Get-Random -Maximum ([array]$csv).count)]
        $verb1n = $verb1.InputObject
        $verb2n = $verb2.InputObject

        ForEach ($count in $filecount)
        {
        $filecount ++
        $Name = $null
        $ext = ($officeextensions = ".pptx",".docx",".doc",".xls",".docx",".doc",".pdf",".ppt",".pdf",".txt") | get-random
        Write-Host $ext
        $name = "$verb1n" + " " + "$verb2n" + "$ext"
        Write-Host $Name
        Copy-Item "$ofile" "$path\$name"
        $verb1 = $null
        $verb2 = $null
        }
        
    }


